/* File implements the Employee object type */


/*****************************************************************************/
/* Constructor function for creating Employee objects.                       */
/* Function takes three arguments:                                           */
/* aFullName - a string representing the employee's name.                    */
/* aAddress - a string representing the employee's address.                  */
/* aYearsWorked - the number number of years the employee worked in company. */
/*****************************************************************************/

function EmployeeType(aFullName, aAddress, aYearsWorked)
{
 //object properties

    this.FullName = aFullName;    
    this.Address  = aAddress;
    this.Years    = new Array(aYearsWorked);

 //object methods

    this.UpdateSalary	= Input_Salary;
    this.AverageSalary	= Disp_Average_Salary;
    this.Display	= Disp_Employee;
};




/********************************************************************************/
/* Function assigned to the UpdateSalary method in the constructor function.    */
/* Function adds a the salaries from previous years.                            */
/* Function takes two arguments:                                                */
/* Year_Num - a number representing the number of the years                     */
/*         for which the employer is worked for.                                */
/* Salary - a number representing the salary for the employee in that year.     */
/* Function returns no value.                                                   */
/********************************************************************************/

function Input_Salary(Year_Num, Salary)
{
	// arrays in Javascript are zero based
	// so we deduct 1 from the year number

	this.Years[Year_Num - 1] = Salary
};






/**********************************************************************************/
/* Function assigned to the AverageSalary method in the constructor function.     */
/* Function takes no arguments.                                                   */
/* Function displays the average salary on the current page.                      */
/* Function returns no value.                                                     */
/**********************************************************************************/

function Disp_Average_Salary()
{
	var total = 0;
	var average;
	var index;

	for (index = 0; index < this.Years.length; index = index + 1)
	{
		total = total + this.Years[index]
	};

	average = total / this.Years.length;
	document.write('Average salary for ' + this.FullName + ': '+ average +'<BR>');
	document.write('*****************************<BR>');
	document.write('<BR>')
};




/********************************************************************************/
/* Function assigned to the display method in the constructor function.         */
/* Function takes no arguments.                                                 */
/* Function displays the employee's details (name, address,                     */
/* and salaries) on the current page.                                           */
/* Function returns no value.                                                   */
/********************************************************************************/

function Disp_Employee()
{    
	document.write('*****************************<BR>');
	document.write('Name: ' + this.FullName);
	document.write('<BR>');
	document.write('Address: ' + this.Address);
	document.write('<BR>');
	document.write('Salaries: ' + this.Years.toString());
	document.write('<BR>')
};





/********************************************************************************/
/* Function assigned to the display software title.                             */
/* Function takes no arguments.                                                 */
/* Function displays the software title 		                        */
/* Function returns no value.                                                   */
/********************************************************************************/

function Disp_Title()
{    
	document.write('<H1>Company Database Software Version 2.0</H1>');
	document.write('<BR>')
};

